extends Node2D

var target
var speed
var hitpoint
var distancetaken = 0

func set_targe(_target : Node2D) -> void:
	target = _target

func set_speed(_speed: int) -> void:
	speed = _speed
	
func set_hitpoint(_hitpoint: int) -> void:
	hitpoint = _hitpoint
	
func _process(delta: float) -> void:
	if target and speed > 0:
		# Get the direction vector from the bullet to the target
		var direction = (target.get_parent().get_parent().get_position() - position).normalized()

		# Rotate the bullet to face the target
		if name.contains("Arrow"):
			rotation = direction.angle() + deg_to_rad(90)

		# Move the bullet towards the target
		position += direction * speed * delta
		distancetaken += (direction * speed * delta).length()
		
		if position.distance_to(target.get_parent().get_parent().position) <= 5:
			target_reached()
		if distancetaken > 250:
			queue_free()
	else:
		queue_free()
	
	
func target_reached() -> void:
	var chance = 0
	if name.contains("Arrow"):				#special effects here!
		if randf() < 0.1:
			target.get_parent().set_speed(target.get_parent().get_speed() / 2)
		pass
	if name.contains("Magic"):
		if randf() < 0.5:
			target.get_parent().set_progress(max(target.get_parent().get_progress() - 60, 0))
	
	
	
	target.get_parent().enemy_hurt(hitpoint)
	queue_free()
